From f097e09067f044f25db7546375654d1734898b7f Mon Sep 17 00:00:00 2001
From: Wang Ziming <wangziming@huawei.com>
Date: Fri, 24 Apr 2020 15:24:49 +0800
Subject: [PATCH 51/77] virtual_disks_multidisk: Retain pcie-root-port and
 pcie-to-pci-bridge when modifying VM XML

Pcie-root-port and pcie-to-pci-bridge when modifying VM XML should be
retained,Otherwise it will be an error:"XML error: Invalid PCI address".

Signed-off-by: Wang Ziming <wangziming@huawei.com>
---
 .../virtual_disks/virtual_disks_multidisks.py  | 18 +++++++++++++++++-
 1 file changed, 17 insertions(+), 1 deletion(-)

diff --git a/libvirt/tests/src/virtual_disks/virtual_disks_multidisks.py b/libvirt/tests/src/virtual_disks/virtual_disks_multidisks.py
index 28c164bc..4f82117e 100644
--- a/libvirt/tests/src/virtual_disks/virtual_disks_multidisks.py
+++ b/libvirt/tests/src/virtual_disks/virtual_disks_multidisks.py
@@ -1291,6 +1291,13 @@ def run(test, params, env):
         # Add virtio_scsi controller.
         if virtio_scsi_controller:
             scsi_controller = Controller("controller")
+            pci_bridge_controller = Controller("controller")
+            controllers = vmxml.get_devices(device_type="controller")
+            for ctrl in controllers:
+                if ctrl.type == "pci":
+                    if ctrl.model == "pcie-to-pci-bridge":
+                        pci_bridge_controller = ctrl
+                        break
             scsi_controller.type = "scsi"
             ctl_type = params.get("virtio_scsi_controller_type")
             if ctl_type:
@@ -1318,9 +1325,18 @@ def run(test, params, env):
                 scsi_controller.address = scsi_controller.new_controller_address(attrs=addr_dict)
             if ctl_type:
                 vmxml.del_controller(ctl_type)
+                pcie_root_port_count = 30
+                for i in range(1, pcie_root_port_count):
+                    if i != 3:
+                        pci_root_index = Controller("controller")
+                        pci_root_index.type = "pci"
+                        pci_root_index.index = "%s" % i
+                        pci_root_index.model = "pcie-root-port"
+                        vmxml.add_device(pci_root_index)
+                vmxml.add_device(pci_bridge_controller)
             else:
                 vmxml.del_controller("scsi")
-            vmxml.add_device(scsi_controller)
+                vmxml.add_device(scsi_controller)
 
         # Create second disk,and attach to VM with the same index controller.
         if virt_disk_with_duplicate_scsi_controller_index:
-- 
2.23.0

